#SingleInstance force

;SetWorkingDir %A_ScriptDir%

StringReplace, 1, 1, ",, All
workdir = %1%

IfEqual, workdir,
{
FileSelectFolder, workdir, *%A_ScriptDir%, 1, Select your BG music/ folder...
}

If workdir=
ExitApp

;MsgBox, 0x24, Keep Backups?, Do you want to make a backup copy before starting?
;IfMsgBox Yes
;{
FileCopyDir, %workdir%, %A_ScriptDir%\backup, 1
;}

dither := 0

;MsgBox, 0x24, Dither, Do you want to apply dither during upsampling?
;IfMsgBox Yes
;dither := 1

posytion := 0

Loop, %workdir%\*.acm, 0, 1
{
; don't waste time upsampling files that are going to be replaced with 1PP HQ versions anyway
; 1) BG2 acm files:
if A_LoopFileName in BC1A1.acm,BC1B1.acm,BC1C1.acm,BC1D1.acm,BC1E1.acm,BC1E2.acm,BC1F1.acm,BC1G1.acm
	,BC1H1.acm,BC1J1.acm,BC1ZA.acm,BC1ZD.acm,BC1ZG.acm,BC1ZH.acm,BC1ZJ.acm,BC2A1.acm,BC2A2.acm
	,BC2B1.acm,BC2C1.acm,BC2D1.acm,BC2E1.acm,BC2F1.acm,BC2G1.acm,BC2H1.acm,BC2J1.acm,BC2K1.acm
	,BC2Z.acm,BD1A.acm,BD1B1.acm,BD1B2.acm,BD1B3.acm,BD1C1.acm,BD1D1.acm,BD1D2.acm,BD1E1.acm
	,BD1E2.acm,BD1F1.acm,BD1F2.acm,BD1G1.acm,BD1G2.acm,BD1H1.acm,BD1H2AA.acm,BD1ZA.acm,BD1ZB.acm
	,BD1ZE1.acm,BD1ZH2.acm,BD2A.acm,BD2B1.acm,BD2B2.acm,BD2C1.acm,BD2C2.acm,BD2D1.acm,BD2D2.acm
	,BD2E1.acm,BD2E2.acm,BD2F1.acm,BD2F2.acm,BD2ZA.acm,BD2ZB.acm,BD2ZC.acm,BD2ZF.acm,BD2ZG2.acm
	,BD3A1.acm,BD3A2.acm,BD3B1.acm,BD3B2.acm,BD3C1.acm,BD3C2.acm,BD3C3A.acm,BD3C3B.acm,BD3D1.acm
	,BD3E1.acm,BD3F1A.acm,BD3F2.acm,BD3G1.acm,BD3G2.acm,BD3Z.acm,BF1A.acm,BF1B1.acm,BF1B2.acm
	,BF1C1.acm,BF1C2.acm,BF1C3.acm,BF1D1.acm,BF1E1.acm,BF1E2.acm,BF1F1.acm,BF1F2.acm,BF1F3.acm
	,BF1G1.acm,BF1H1.acm,BF1H2.acm,BF1Z.acm,BF1ZB.acm,BF1ZC.acm,BF2A.acm,BF2B1.acm,BF2B2.acm
	,BF2C1.acm,BF2C2.acm,BF2D1.acm,BF2D2.acm,BF2E1.acm,BF2F1.acm,BF2F2.acm,BF2J1.acm,BF2J2.acm
	,BF2J3.acm,BF2Z.acm,BF2ZA.acm,BF2ZF1.acm,BF2ZF2.acm,BF2ZJ1.acm,BF2ZJ3.acm,BJRA.acm,BJRB1.acm
	,BJRB2.acm,BJRC1.acm,BJRC2.acm,BJRD1.acm,BJRD2.acm,BJRE1.acm,BJRE2.acm,BJRF1.acm,BJRF2.acm
	,BJRG1.acm,BJRH1.acm,BJRH2.acm,BJRZ.acm,BJRZB.acm,BLANKA.acm,BM1A.acm,BM1B1.acm,BM1B2.acm
	,BM1C1.acm,BM1C2.acm,BM1D1.acm,BM1D2.acm,BM1E1.acm,BM1F1.acm,BM1G1.acm,BM1H1.acm,BM1J1.acm
	,BM1J2.acm,BM1ZA.acm,BM1ZB.acm,BM2A.acm,BM2B1.acm,BM2B2.acm,BM2C1.acm,BM2C2.acm,BM2D1.acm
	,BM2E1.acm,BM2F1.acm,BM2G1.acm,BM2H1J1.acm,BM2K1.acm,BM2M1.acm,BM2N1.acm,BM2ZA.acm,BM2ZB.acm
	,BP1A.acm,BP1B1.acm,BP1B2.acm,BP1C1.acm,BP1C2.acm,BP1D1.acm,BP1E1.acm,BP1E2.acm,BP1F1.acm,BP1F2.acm
	,BP1G1.acm,BP1G2.acm,BP1H1.acm,BP1H2.acm,BP1H3.acm,BP1ZA.acm,BP1ZB.acm,BP2A.acm,BP2B1.acm
	,BP2B2.acm,BP2C1.acm,BP2C2.acm,BP2D1.acm,BP2D2.acm,BP2E1.acm,BP2E2.acm,BP2F1.acm,BP2G1A.acm
	,BP2H1A.acm,BP2H2.acm,BP2H3.acm,BP2J1.acm,BP2J2.acm,BP2K1.acm,BP2Z.acm,BP2ZA.acm,BRDA1.acm
	,BRDA2.acm,BRDB1.acm,BRDB2.acm,BRDC1.acm,BRDC2.acm,BRDD1.acm,BRDD2.acm,BRDE1.acm,BRDE2.acm
	,BRDF1.acm,BRDG.acm,BRDH1.acm,BRDH2.acm,BRDZA.acm,BRDZB.acm,BRDZC.acm
	,BRDZE.acm,BRDZG.acm,BSDA1.acm,BSDA2.acm,BSDA3.acm,BSDB1.acm,BSDB2.acm,BSDB3.acm,BSDC1.acm
	,BSDC2.acm,BSDC3.acm,BSDD1.acm,BSDD2.acm,BSDD3.acm,BSDE1.acm,BSDE2.acm,BSDF1.acm,BSDF2A.acm
	,BSDZ.acm,BSDZA3.acm,BSDZD.acm,BSDZF1.acm,BSDZF2.acm,BSTA.acm,BSTB.acm,BSTC1.acm,BSTC2.acm
	,BSTD1.acm,BSTD2.acm,BSTF1.acm,BSTF2.acm,BSTG1.acm,BSTG2.acm,BSTH1.acm,BSTH2.acm,BSTJ1.acm
	,BSTZA.acm,BSTZB.acm,BSTZC.acm,BSTZG1.acm,BSTZG2.acm,BSTZH2.acm,Combo1a.acm,Combo1b.acm
	,Combo2a.acm,Combo2b.acm,Combo2C.acm,Dream1A.acm,harp_v2a.acm,harp_v2b.acm,harp_v21c.acm
	,harp_v6a.acm,harp_v6b.acm,harp_v6c.acm,MB_A1.acm,MB_A2.acm,MB_B1.acm,MB_B2.acm,MB_B3.acm,MB_B4.acm
	,MB_B5.acm,MB_C1.acm,MB_C2.acm,MB_C3.acm,MB_C4.acm,MB_D1.acm,MB_D2.acm,MB_D3.acm,MB_E1.acm
	,MB_E2.acm,MB_F1.acm,MB_F2.acm,MB_F3.acm,MB_G1.acm,MB_G2.acm,MB_G3.acm,MX0011a.acm,MX0012a.acm
	,MX0013a.acm,mx0015a.acm,MX0020a.acm,MX0021a.acm,MX0202a.acm,MX0204a.acm,MX0300a.acm,MX0313a.acm
	,MX0400a.acm,MX0400na.acm,MX0404a.acm,mx0406a.acm,MX0410a.acm,MX0414a.acm,MX0500a.acm,MX0512a.acm
	,MX0516a.acm,MX0602a.acm,MX0700a.acm,MX0900a.acm,MX1100a.acm,MX1200a.acm,MX1201a.acm,MX1300a.acm
	,MX1304a.acm,MX1400a.acm,MX1500a.acm,MX1600a.acm,MX1900a.acm,MX2000a.acm,MX2100a.acm,MX2300a.acm
	,MX4500a.acm,MX5000a.acm,MX5500a.acm,Mx6000a.acm,Mx6100a.acm,MX6200a.acm,MxAerieA.acm,MxAnomA.acm
	,MxJahirA.acm,MxKalahA.acm,MxKhaliA.acm,MxThiefA.acm,MxViconA.acm,Tav1a.acm,Tav2a.acm,Tav3a.acm,Tav4a.acm
	,THEMEA.acm,themeB.acm,themec.acm,themed.acm,VB_A1.acm,VB_B1.acm,VB_B2.acm,VB_B3.acm,VB_B4.acm,VB_B5.acm
	,VB_B6.acm,VB_C1.acm,VB_C2.acm,VB_D1.acm,VB_D2.acm,VB_E1.acm,VB_E2.acm,VB_E3.acm,VB_E4.acm,VB_E5.acm
	,VB_F1.acm,VB_F2.acm,VB_G1.acm,VB_G2.acm,VB_G3.acm,VB_H1.acm,VB_H2.acm,VB_I1.acm,VB_I2.acm,VB_I3.acm
      continue

; 2) BGT acm files:
if A_LoopFileName in bc3a1.acm,bc3a2.acm,bc3a3.acm,bc3a4.acm,bc3b1.acm,bc3b2.acm,bc3b3.acm,bc3c1.acm,bc3d1.acm
	,bc3d2.acm,bc3d3.acm,bc3d4.acm,bc3e1.acm,bc3e2.acm,bc3e3.acm,bc3e4.acm,bc3enda1.acm,bc3enda4.acm
	,bc3endb1.acm,bc3endb2.acm,bc3endb3.acm,bc3endc1.acm,bc3endd1.acm,bc3endd2.acm,bc3endd4.acm,bc3ende1.acm
	,bc3ende2.acm,bc3ende4.acm,bc3endf2.acm,bc3endf4.acm,bc3endg2.acm,bc3endg3.acm,bc3endh2.acm,bc3endh3.acm
	,bc3endh4.acm,bc3f1.acm,bc3f2.acm,bc3f3.acm,bc3f4.acm,bc3g1.acm,bc3g2.acm,bc3g3.acm,bc3h1.acm,bc3h2.acm
	,bc3h3.acm,bc3h4.acm,bc3i1.acm,bc4a1.acm,bc4a2.acm,bc4a3.acm,bc4b1.acm,bc4b2.acm,bc4c1.acm,bc4c2.acm,bc4d1.acm
	,bc4d2.acm,bc4e1.acm,bc4e2.acm,bc4enda.acm,bc4endb.acm,bc4endc.acm,bc4f1.acm,bc4f2.acm,bc4g1.acm,bc4g2.acm
	,bc4g3.acm,bc4h1.acm,bc4h2.acm,bc4h3.acm,bc4h4.acm,bc4i1.acm,bc4i2.acm,bc4i3.acm,bc4i4.acm,bc4j1.acm,bc4j2.acm
	,bc4j3.acm,bc4j4.acm,bc4k1.acm,bc4k2.acm,bc4k3.acm,bc4xa1.acm,bd4a1.acm,bd4a2.acm,bd4b1.acm,bd4b2.acm,bd4b3.acm
	,bd4b4.acm,bd4c1.acm,bd4c2.acm,bd4d1.acm,bd4d2.acm,bd4d3.acm,bd4e1.acm,bd4e2.acm,bd4e3.acm,bd4e4.acm,bd4enda.acm
	,bd4endb.acm,bd4endc.acm,bd4f1.acm,bd4f2.acm,bd4f3.acm,bd4g1.acm,bd4g2.acm,bd4g3a.acm,bd4g4a.acm,bd4h1.acm
	,bd4h2.acm,bd4h3.acm,bd4i12.acm,bd4xa1.acm,bd5a1.acm,bd5a2.acm,bd5a3.acm,bd5b1.acm,bd5b2.acm,bd5c1.acm
	,bd5c2.acm,bd5c3.acm,bd5c4.acm,bd5d1.acm,bd5d2.acm,bd5d3.acm,bd5d4.acm,bd5e1.acm,bd5e2.acm,bd5e3.acm,bd5e4.acm
	,bd5enda1.acm,bd5enda2.acm,bd5endb1.acm,bd5endb2.acm,bd5endd1.acm,bd5ende1.acm,bd5endg3.acm,bd5f1.acm,bd5f2.acm
	,bd5f3.acm,bd5f4.acm,bd5g1a.acm,bd5g2b.acm,bd5g3.acm,bf3a1.acm,bf3a2.acm,bf3a3.acm,bf3b1.acm,bf3b2.acm,bf3c1.acm
	,bf3d1.acm,bf3d2.acm,bf3e1.acm,bf3e2.acm,bf3enda.acm,bf3endb.acm,bf3endc.acm,bf3endd.acm,bf3ende.acm,bf3endf.acm
	,bf3endg.acm,bf3f1.acm,bf3f2.acm,bf3f3.acm,bf3g1.acm,bf3g2.acm,bf3g3.acm,bf3h1.acm,bf3h2.acm,bf3i1.acm,bf3i2.acm
	,bf3i3.acm,bf3j1.acm,bf3j2.acm,bf3j3.acm,bf3j4.acm,bf3j5.acm,bf4a1.acm,bf4a2.acm,bf4a3.acm,bf4a4.acm,bf4b1.acm
	,bf4b2.acm,bf4b3.acm,bf4b4.acm,bf4c1.acm,bf4c2.acm,bf4c3.acm,bf4c4.acm,bf4d1.acm,bf4d2.acm,bf4d3.acm,bf4d4.acm
	,bf4e1.acm,bf4e2.acm,bf4enda1.acm,bf4enda2.acm,bf4enda3.acm,bf4enda4.acm,bf4endc1.acm,bf4endd1.acm,bf4endd2.acm
	,bf4endd4.acm,bf4endf1.acm,bf4endf2.acm,bf4endf3.acm,bf4endg3.acm,bf4endg4.acm,bf4f1.acm,bf4f2.acm,bf4f3.acm
	,bf4f4.acm,bf4g1.acm,bf4g2.acm,bf4g3.acm,bf4g4.acm,bf4h1.acm,bf4h2.acm,bf4h3.acm,bf4h4.acm,bgthemea.acm,Bl1a1.acm
	,Bl1a3.acm,Bl1a4.acm,Bl1b1.acm,Bl1b2.acm,Bl1b3.acm,Bl1b4.acm,Bl1c1.acm,Bl1c2.acm,Bl1c3.acm,Bl1c4.acm,Bl1d1.acm
	,Bl1d2.acm,Bl1d3.acm,Bl1e1.acm,Bl1e2.acm,Bl1e3.acm,Bl1e4a.acm,Bl1enda1.acm,Bl1enda4.acm,Bl1endb1.acm,Bl1endb2.acm
	,Bl1endb3.acm,Bl1endc1.acm,Bl1ende4.acm,Bl1f1a.acm,Bl1f2.acm,Bl1f3.acm,Bl1f4.acm,Bl1g1.acm,Bl1g2.acm,Bl1g3.acm
	,Bl1h1.acm,Bl1h2.acm,Bl1xa4.acm,Bl2a1.acm,Bl2a2.acm,Bl2a3.acm,Bl2a4.acm,Bl2b1.acm,Bl2b2.acm,Bl2b3.acm,Bl2b4.acm
	,Bl2c1.acm,Bl2c2.acm,Bl2c3.acm,Bl2c4.acm,Bl2d1.acm,Bl2d2.acm,Bl2e1.acm,BL2endA.acm,BL2endB.acm,BL2endC.acm
	,BL2endD.acm,BL2endE.acm,Bl2f1.acm,Bl2f2.acm,Bl2g1.acm,Bl2g2.acm,Bl2g3.acm,Bl2h1.acm,Bl2h2.acm,Bl2h3.acm
	,Bl2h4.acm,Bl2h5.acm,Bl2h6.acm,bp3a1.acm,bp3a2.acm,bp3a3.acm,bp3b1.acm,bp3b2.acm,bp3b3.acm,bp3c1.acm,bp3c2.acm
	,bp3d1.acm,bp3d2.acm,bp3d3.acm,bp3enda1.acm,bp3enda2.acm,bp3endb1.acm,bp3endb2.acm,bp3endc2.acm,bp3endd1.acm
	,bp3endd2.acm,bp3endz1.acm,bp4a1.acm,bp4a2.acm,bp4a3.acm,bp4b1.acm,bp4b2.acm,bp4c1.acm,bp4c2.acm,bp4d1.acm
	,bp4d2.acm,bp4d3.acm,bp4d4.acm,bp4e1.acm,bp4e2.acm,bp4e3.acm,bp4e4.acm,bp4e5.acm,bp4enda1.acm,bp4endc1.acm
	,bp4endc2.acm,bp4endd1.acm,bp4endd2.acm,bp4endd3.acm,bp4endf1.acm,bp4endf4.acm,bp4endg4.acm,bp4endh1.acm
	,bp4endh3.acm,bp4endz1.acm,bp4f1.acm,bp4f2.acm,bp4f3.acm,bp4f4.acm,bp4g1.acm,bp4g2.acm,bp4g3.acm,bp4g4.acm
	,bp4h1.acm,bp4h2.acm,bp4h3.acm,bp4xa1.acm,bp4z1.acm,Bw1a1.acm,Bw1a3.acm,Bw1a4.acm,Bw1b1.acm,Bw1b2.acm
	,Bw1b3.acm,Bw1b4.acm,Bw1c1.acm,Bw1c2.acm,Bw1c3.acm,Bw1c4.acm,Bw1d1.acm,Bw1d2.acm,Bw1d3.acm,Bw1d4.acm
	,Bw1e1.acm,Bw1e2.acm,Bw1e3.acm,Bw1e4.acm,Bw1enda1.acm,Bw1enda3.acm,Bw1endb1.acm,Bw1endb2.acm,Bw1endb4.acm
	,Bw1endd3.acm,Bw1endd4.acm,Bw1ende1.acm,Bw1ende2.acm,Bw1endf1.acm,Bw1endf2.acm,Bw1f1.acm,Bw1f2.acm,Bw1g12.acm
	,Bw1h1.acm,Bw1h2.acm,CDay1a.acm,CDay2a.acm,Chantsa.acm,CNitea.acm,Dreama.acm,Dung1a.acm,Dung2a.acm,Dung3a.acm
	,FDaya.acm,FNitea.acm,Forta.acm,PDaya.acm,PNitea.acm,tav5a.acm,tav6a.acm,tav7a.acm,tav8a.acm,TDay1a.acm
	,TDay2a.acm,Templea.acm,TNitea.acm
   continue

FileMove, %A_LoopFileFullPath%, %A_ScriptDir%\temp, 1
RunWait, %A_ScriptDir%\acmtools\acm2wav.exe %A_ScriptDir%\temp\%A_LoopFileName%, %A_ScriptDir%, Hide

StringTrimRight, namenoext, A_LoopFileName, 4
FileMove, %A_ScriptDir%\%namenoext%.wav, %A_ScriptDir%\temp

IfEqual, dither, 1
RunWait, %A_ScriptDir%\ssrc-1.30\ssrc_hp.exe --rate 44100 --dither 1 --bits 16 --twopass --quiet %A_ScriptDir%\temp\%namenoext%.wav %A_ScriptDir%\temp\%namenoext%44.wav, %A_ScriptDir%, Hide

IfEqual, dither, 0
RunWait, %A_ScriptDir%\ssrc-1.30\ssrc_hp.exe --rate 44100 --bits 16 --twopass --quiet %A_ScriptDir%\temp\%namenoext%.wav %A_ScriptDir%\temp\%namenoext%44.wav, %A_ScriptDir%, Hide

RunWait, %A_ScriptDir%\acmtools\snd2acm.exe %A_ScriptDir%\temp\%namenoext%44.wav %A_ScriptDir%\temp\%namenoext%44.acm -q0, %A_ScriptDir%, Hide

FileMove, %A_ScriptDir%\temp\%namenoext%44.acm, %A_LoopFileFullPath%, 1
FileDelete, %A_ScriptDir%\temp\*.*
posytion++
Progress, m2 b fs18 zh0, Processing file: %A_LoopFileName%, , , Courier New
}

Progress, Off